/**
*     Copyright (c) 2022, NSING Technologies Pte. Ltd.
*
*     All rights reserved.
*
*     This software is the exclusive property of NSING Technologies Pte. Ltd. (Hereinafter
* referred to as NSING). This software, and the product of NSING described herein
* (Hereinafter referred to as the Product) are owned by NSING under the laws and treaties
* of the Republic of Singapore and other applicable jurisdictions worldwide.
*
*     NSING does not grant any license under its patents, copyrights, trademarks, or other
* intellectual property rights. Names and brands of third party may be mentioned or referred
* thereto (if any) for identification purposes only.
*
*     NSING reserves the right to make changes, corrections, enhancements, modifications, and
* improvements to this software at any time without notice. Please contact NSING and obtain
* the latest version of this software before placing orders.

*     Although NSING has attempted to provide accurate and reliable information, NSING assumes
* no responsibility for the accuracy and reliability of this software.
*
*     It is the responsibility of the user of this software to properly design, program, and test
* the functionality and safety of any application made of this information and any resulting product.
* In no event shall NSING be liable for any direct, indirect, incidental, special,exemplary, or
* consequential damages arising in any way out of the use of this software or the Product.
*
*     NSING Products are neither intended nor warranted for usage in systems or equipment, any
* malfunction or failure of which may cause loss of human life, bodily injury or severe property
* damage. Such applications are deemed, "Insecure Usage".
*
*     All Insecure Usage shall be made at user's risk. User shall indemnify NSING and hold NSING
* harmless from and against all claims, costs, damages, and other liabilities, arising from or related
* to any customer's Insecure Usage.

*     Any express or implied warranty with regard to this software or the Product, including,but not
* limited to, the warranties of merchantability, fitness for a particular purpose and non-infringement
* are disclaimed to the fullest extent permitted by law.

*     Unless otherwise explicitly permitted by NSING, anyone may not duplicate, modify, transcribe
* or otherwise distribute this software for any purposes, in whole or in part.
*
*     NSING products and technologies shall not be used for or incorporated into any products or systems
* whose manufacture, use, or sale is prohibited under any applicable domestic or foreign laws or regulations.
* User shall comply with any applicable export control laws and regulations promulgated and administered by
* the governments of any countries asserting jurisdiction over the parties or transactions.
**/

/**
 *\*\file TIM8_remap.h
 *\*\author NSING
 *\*\version v1.0.0
 *\*\copyright Copyright (c) 2022, NSING Technologies Pte. Ltd. All rights reserved.
 **/
#ifndef TIM8_REMAP_H
#define TIM8_REMAP_H

#include "n32g430_gpio.h"

/** TIM8 remap **/
/* ETR */
#define TIM8_REMAP0_ETR_PORT GPIOA
#define TIM8_REMAP0_ETR_PIN GPIO_PIN_0
#define TIM8_REMAP0_ETR_AF GPIO_AF8_TIM8
/* CH1 */
#define TIM8_REMAP0_CH1_PORT GPIOA
#define TIM8_REMAP0_CH1_PIN GPIO_PIN_2
#define TIM8_REMAP0_CH1_AF GPIO_AF9_TIM8
/* CH2 */
#define TIM8_REMAP0_CH2_PORT GPIOA
#define TIM8_REMAP0_CH2_PIN GPIO_PIN_3
#define TIM8_REMAP0_CH2_AF GPIO_AF10_TIM8
/* CH3 */
#define TIM8_REMAP0_CH3_PORT GPIOA
#define TIM8_REMAP0_CH3_PIN GPIO_PIN_4
#define TIM8_REMAP0_CH3_AF GPIO_AF9_TIM8
/* CH4 */
#define TIM8_REMAP0_CH4_PORT GPIOA
#define TIM8_REMAP0_CH4_PIN GPIO_PIN_5
#define TIM8_REMAP0_CH4_AF GPIO_AF9_TIM8

/* BKIN */
#define TIM8_REMAP0_BKIN_PORT GPIOA
#define TIM8_REMAP0_BKIN_PIN GPIO_PIN_6
#define TIM8_REMAP0_BKIN_AF GPIO_AF7_TIM8
/* CH1N */
#define TIM8_REMAP0_CH1N_PORT GPIOA
#define TIM8_REMAP0_CH1N_PIN GPIO_PIN_7
#define TIM8_REMAP0_CH1N_AF GPIO_AF7_TIM8
/* CH2N */
#define TIM8_REMAP0_CH2N_PORT GPIOB
#define TIM8_REMAP0_CH2N_PIN GPIO_PIN_3
#define TIM8_REMAP0_CH2N_AF GPIO_AF8_TIM8
/* CH3N */
#define TIM8_REMAP0_CH3N_PORT GPIOB
#define TIM8_REMAP0_CH3N_PIN GPIO_PIN_6
#define TIM8_REMAP0_CH3N_AF GPIO_AF13_TIM8

#endif
